--RandomMount V0.9.4
--Author: Mike Hendricks(AttilaTheFun)
--Description:
--              This add-on makes it simple to summon a random mount it takes into account ridding level, cold weather flying,
--              flying areas, even race and summons an appropriate mount.
--              It has a simple interface /mnt: /rmount: Will summon riding/flying mounts in the appropriate areas. mnt and rmount are interchangeable
--                                        /mnt riding: Summons riding mounts in flying areas
--                                        /mnt flying: Attempt to summon a flying mount
--                                        /mnt help: Display help
--                                        /mnt % (search Term): Summons a mount based on specified search term
--                                                example: to summon a skeletal warhorse type: /mnt skeletal
--                                        /mnt epicfly: Toggle summoning of epic flying mounts
--                                        /mnt epicride: Toggle summoning of epic riding mounts
--                                        /mnt config: Prints the current configuration
--                                        /mnt locfilter: Toggle filter to summon only specific mounts in specific locations
--                                        /mnt rfilter: Toggle mount filtering
--                                        /mnt safefly: Toggle double click to dismount while flying
--                                        /mnt rfilters: List current filters
--                                        /mnt addloc % (search term): Add % to the location mount filter if locfilter is enabled
--                                        /mnt addmount % (search term): Add % to the location filter if locfilter is enabled
--                                        /mnt remove %: Remove all mounts matching % if rfilter is enabled
--                                        /mnt clear: Clears all filters
--                                        /mnt clearrem: Clears the mount removal table
--                                        /mnt clearloc: Clears location filters
--                                        /mnt clearmount: Clears mount filters for locations
--                                        /mnt whereami: Prints your zone and mini-map zone.
--                                        /mnt title: Enable or disable random title change.
--                                        /mnt debug: Toggle debug printing for posting error messages
--                                        /mnt No Flag: Summon a appropriate mount for the area

--If you are in undercity most mounts are to large to get easily throug out of the elivators, so if you have wolf,
-- or skeletal warhorses it will summon only those inside of undercity.

-- mount dictionary to compensate for wow's terrible GetCompanionInfo("MOUNT", i) command.
--One would assume info would imply useful things like can it fly and what skill is required etc.
-- mount codes --
-- add the numbers together for special mounts. ie both epic riding and epic flying = 20
--1  = slow Mount(Not Summoned)
--2  = riding mount
--4  = epic riding mount
--8  = flying mount
--16 = epic flying mount
--32 = special mount(for area specific mounts)

-- missing mounts
--'Thalassian Warhorse': 4, 'Thalassian Charger': 4,

local mountDict = {
[60025]={16, "Albino Drake"},
[43688]={4, "Amani War Bear"},
[16056]={4, "Ancient Frostsaber"},
[48778]={4, "Acherus Deathcharger"},
[66906]={4, "Argent Charger"},
[63844]={16, "Argent Hippogryph"},
[67466]={4, "Argent Warhorse"},
[61230]={16, "Armored Blue Wind Rider"},
[60114]={4, "Armored Brown Bear"},
[60116]={4, "Armored Brown Bear"},
[61229]={16, "Armored Snowy Gryphon"},
[40192]={16, "Ashes of Al'ar"},
[59567]={16, "Azure Drake"},
[41514]={16, "Azure Netherwing Drake"},
[51412]={4, "Big Battle Bear"},
[58983]={6, "Big Blizzard Bear"},
[64987]={6, "Big Blizzard Bear [PH]"},
[22719]={4, "Black Battlestrider"},
[62048]={16, "Black Dragonhawk Mount"},
[59650]={16, "Black Drake"},
[35022]={2, "Black Hawkstrider"},
[16055]={4, "Black Nightsaber"},
[59572]={2, "Black Polar Bear"},
[59976]={16, "Black Proto-Drake"},
[26656]={4, "Black Qiraji Battle Tank"},
[6896]={4, "Black Ram"},
[17461]={4, "Black Ram"},
[64977]={2, "Black Skeletal Horse"},
[470]={2, "Black Stallion"},
[60118]={4, "Black War Bear"},
[60119]={4, "Black War Bear"},
[48027]={4, "Black War Elekk"},
[22718]={4, "Black War Kodo"},
[59785]={4, "Black War Mammoth"},
[59788]={4, "Black War Mammoth"},
[22720]={4, "Black War Ram"},
[22721]={36, "Black War Raptor"},
[22717]={4, "Black War Steed"},
[22723]={4, "Black War Tiger"},
[22724]={36, "Black War Wolf"},
[578]={2, "Black Wolf"},
[64658]={2, "Black Wolf"},
[61996]={16, "Blue Dragonhawk"},
[59568]={16, "Blue Drake"},
[35020]={2, "Blue Hawkstrider"},
[10969]={2, "Blue Mechanostrider"},
[33630]={2, "Blue Mechanostrider"},
[59996]={16, "Blue Proto-Drake"},
[25953]={32, "Blue Qiraji Battle Tank"},
[6897]={2, "Blue Ram"},
[39803]={16, "Blue Riding Nether Ray"},
[17463]={34, "Blue Skeletal Horse"},
[64656]={32, "Blue Skeletal Warhorse"},
[32244]={8, "Blue Wind Rider"},
[50869]={2, "Brewfest Kodo"},
[43899]={4, "Brewfest Ram"},
[50870]={4, "Brewfest Ram"},
[49378]={2, "Brewfest Riding Kodo"},
[59569]={16, "Bronze Drake"},
[34406]={2, "Brown Elekk"},
[458]={2, "Brown Horse"},
[18990]={2, "Brown Kodo"},
[59573]={4, "Brown Polar Bear"},
[6899]={2, "Brown Ram"},
[17464]={34, "Brown Skeletal Horse"},
[6654]={34, "Brown Wolf"},
[58615]={16, "Brutal Nether Drake"},
[43927]={16, "Cenarion War Hippogryph"},
[23214]={4, "Charger"},
[6648]={2, "Chestnut Mare"},
[41515]={16, "Cobalt Netherwing Drake"},
[39315]={4, "Cobalt Riding Talbuk"},
[34896]={4, "Cobalt War Talbuk"},
[39316]={4, "Dark Riding Talbuk"},
[34790]={4, "Dark War Talbuk"},
[63635]={4, "Darkspear Raptor"},
[63637]={4, "Darnassian Nightsaber"},
[64927]={16, "Deadly Gladiator's Frostwyrm"},
[6653]={34, "Dire Wolf"},
[23161]={4, "Dreadsteed"},
[32239]={8, "Ebon Gryphon"},
[8395]={34, "Emerald Raptor"},
[63639]={4, "Exodar Elekk"},
[5784]={2, "Felsteed"},
[36702]={4, "Fiery Warhorse"},
[17458]={2, "Fluorescent Green Mechanostrider"},
[61451]={8, "Flying Carpet"},
[44153]={8, "Flying Machine"},
[63643]={4, "Forsaken Warhorse"},
[17460]={4, "Frost Ram"},
[43810]={16, "Frost Wyrm"},
[23509]={36, "Frostwolf Howler"},
[51960]={16, "Frostwyrm Mount"},
[63638]={4, "Gnomeregan Mechanostrider"},
[32235]={8, "Golden Gryphon"},
[16060]={2, "Golden Sabercat"},
[59810]={4, "Grand Black War Mammoth"},
[59811]={4, "Grand Black War Mammoth"},
[61465]={4, "Grand Black War Mammoth"},
[61467]={4, "Grand Black War Mammoth"},
[60136]={4, "Grand Caravan Mammoth"},
[60140]={4, "Grand Caravan Mammoth"},
[59802]={4, "Grand Ice Mammoth"},
[59804]={4, "Grand Ice Mammoth"},
[61469]={4, "Grand Ice Mammoth"},
[61470]={4, "Grand Ice Mammoth"},
[35710]={2, "Gray Elekk"},
[18989]={2, "Gray Kodo"},
[6777]={2, "Gray Ram"},
[459]={2, "Gray Wolf"},
[63639]={4, "Great Azuremyst Elekk"},
[35713]={4, "Great Blue Elekk"},
[49379]={4, "Great Brewfest Kodo"},
[23249]={4, "Great Brown Kodo"},
[34407]={4, "Great Elite Elekk"},
[65641]={4, "Great Golden Kodo"},
[23248]={4, "Great Gray Kodo"},
[35712]={4, "Great Green Elekk"},
[63641]={4, "Great Mulgore Kodo"},
[35714]={4, "Great Purple Elekk"},
[65637]={4, "Great Red Elekk"},
[23247]={4, "Great White Kodo"},
[18991]={4, "Green Kodo"},
[15780]={2, "Green Mechanostrider"},
[17453]={2, "Green Mechanostrider"},
[61294]={16, "Green Proto-Drake"},
[26056]={32, "Green Qiraji Battle Tank"},
[39798]={16, "Green Riding Nether Ray"},
[17465]={36, "Green Skeletal Warhorse"},
[32245]={8, "Green Wind Rider"},
[48025]={20, "Headless Horseman's Mount"},
[59797]={4, "Ice Mammoth"},
[59799]={4, "Ice Mammoth"},
[17459]={4, "Icy Blue Mechanostrider Mod A"},
[63956]={16, "Ironbound Proto-Drake"},
[63636]={4, "Ironforge Ram"},
[10795]={4, "Ivory Raptor"},
[17450]={4, "Ivory Raptor"},
[65917]={4, "Magic Rooster"},
[66122]={4, "Magic Rooster"},
[66123]={4, "Magic Rooster"},
[66124]={4, "Magic Rooster"},
[61309]={16, "Magnificent Flying Carpet"},
[55531]={4, "Mechano-hog"},
[60424]={4, "Mekgineer's Chopper"},
[44317]={16, "Merciless Nether Drake"},
[44744]={16, "Merciless Nether Drake"},
[63796]={16, "Mimiron's Head"},
[16084]={4, "Mottled Red Raptor"},
[29059]={4, "Naxxramas Deathcharger"},
[3363]={16, "Nether Drake"},
[28828]={16, "Nether Drake"},
[10798]={2, "Obsidian Raptor"},
[41513]={16, "Onyx Netherwing Drake"},
[66846]={4, "Ochre Skeletal Warhorse"},
[63640]={4, "Orgrimmar Wolf"},
[471]={2, "Palamino"},
[16082]={4, "Palomino"},
[32345]={16, "Peep the Phoenix Mount"},
[472]={2, "Pinto"},
[60021]={16, "Plagued Proto-Drake"},
[16058]={2, "Primal Leopard"},
[35711]={2, "Purple Elekk"},
[35018]={2, "Purple Hawkstrider"},
[17455]={2, "Purple Mechanostrider"},
[41516]={16, "Purple Netherwing Drake"},
[39801]={16, "Purple Riding Nether Ray"},
[23246]={36, "Purple Skeletal Warhorse"},
[66090]={4, "Quel'dorei Steed"},
[41252]={4, "Raven Lord"},
[17456]={2, "Red and Blue Mechanostrider"},
[61997]={2, "Red Dragonhawk"},
[59570]={16, "Red Drake"},
[34795]={2, "Red Hawkstrider"},
[10873]={2, "Red Mechanostrider"},
[59961]={16, "Red Proto-Drake"},
[26054]={32, "Red Qiraji Battle Tank"},
[39800]={16, "Red Riding Nether Ray"},
[17462]={34, "Red Skeletal Horse"},
[22722]={36, "Red Skeletal Warhorse"},
[579]={4, "Red Wolf"},
[16080]={4, "Red Wolf"},
[18363]={2, "Riding Kodo"},
[30174]={1, "Riding Turtle"},
[17481]={36, "Rivendare's Deathcharger"},
[63963]={16, "Rusted Proto-Drake"},
[64731]={2, "Sea Turtle"},
[66087]={16, "Silver Covenant Hippogryph"},
[39802]={16, "Silver Riding Nether Ray"},
[39317]={4, "Silver Riding Talbuk"},
[34898]={4, "Silver War Talbuk"},
[63642]={4, "Silvermoon Hawkstrider"},
[8980]={2, "Skeletal Horse"},
[32240]={8, "Snowy Gryphon"},
[42776]={2, "Spectral Tiger"},
[10789]={2, "Spotted Frostsaber"},
[15781]={2, "Steel Mechanostrider"},
[23510]={4, "Stormpike Battle Charger"},
[63232]={4, "Stormwind Steed"},
[66847]={2, "Striped Dawnsaber"},
[8394]={2, "Striped Frostsaber"},
[10793]={2, "Striped Nightsaber"},
[34767]={4, "Summon Charger"},
[34769]={2, "Summon Warhorse"},
[66091]={4, "Sunreaver Hawkstrider"},
[66088]={16, "Sunreaver Dragonhawk"},
[32242]={16, "Swift Blue Gryphon"},
[23241]={36, "Swift Blue Raptor"},
[43900]={4, "Swift Brewfest Ram"},
[23238]={4, "Swift Brown Ram"},
[23229]={4, "Swift Brown Steed"},
[23250]={36, "Swift Brown Wolf"},
[65646]={4, "Swift Burgundy Wolf"},
[63635]={4, "Swift Darkspear Raptor"},
[63637]={4, "Swift Darnassian Mistsaber"},
[23220]={4, "Swift Dawnsaber"},
[63232]={4, "Swift Elwynn Steed"},
[23221]={4, "Swift Frostsaber"},
[23239]={4, "Swift Gray Ram"},
[65640]={4, "Swift Gray Steed"},
[23252]={36, "Swift Gray Wolf"},
[32290]={16, "Swift Green Gryphon"},
[35025]={4, "Swift Green Hawkstrider"},
[23225]={4, "Swift Green Mechanostrider"},
[32295]={16, "Swift Green Wind Rider"},
[63636]={4, "Swift Ironforge Ram"},
[23219]={4, "Swift Mistsaber"},
[61442]={16, "Swift Mooncloth Carpet"},
[65636]={4, "Swift Moonsaber"},
[65638]={4, "Swift Moonsaber"},
[37015]={16, "Swift Nether Drake"},
[23242]={36, "Swift Olive Raptor"},
[23243]={36, "Swift Orange Raptor"},
[63640]={4, "Swift Orgrimmar Wolf"},
[23227]={4, "Swift Palomino"},
[33660]={4, "Swift Pink Hawkstrider"},
[32292]={16, "Swift Purple Gryphon"},
[35027]={4, "Swift Purple Hawkstrider"},
[65644]={4, "Swift Purple Raptor"},
[32297]={16, "Swift Purple Wind Rider"},
[24242]={4, "Swift Razzashi Raptor"},
[32289]={16, "Swift Red Gryphon"},
[65639]={4, "Swift Red Hawkstrider"},
[32246]={16, "Swift Red Wind Rider"},
[61444]={16, "Swift Shadoweave Carpet"},
[63642]={4, "Swift Silvermoon Hawkstrider"},
[42777]={6, "Swift Spectral Tiger"},
[61446]={16, "Swift Spellfire Carpet"},
[23338]={4, "Swift Stormsaber"},
[23251]={36, "Swift Timber Wolf"},
[65643]={4, "Swift Violet Ram"},
[47037]={4, "Swift War Elekk"},
[35028]={4, "Swift Warstrider"},
[46628]={4, "Swift White Hawkstrider"},
[23223]={4, "Swift White Mechanostrider"},
[23240]={4, "Swift White Ram"},
[23228]={4, "Swift White Steed"},
[23222]={4, "Swift Yellow Mechanostrider"},
[32296]={16, "Swift Yellow Wind Rider"},
[48954]={4, "Swift Zhevra"},
[49322]={4, "Swift Zhevra"},
[24252]={4, "Swift Zulian Tiger"},
[39318]={4, "Tan Riding Talbuk"},
[34899]={4, "Tan War Talbuk"},
[16059]={2, "Tawny Sabercat"},
[32243]={8, "Tawny Wind Rider"},
[18992]={4, "Teal Kodo"},
[63641]={4, "Thunder Bluff Kodo"},
[580]={34, "Timber Wolf"},
[60002]={16, "Time-Lost Proto-Drake"},
[61425]={4, "Traveler's Tundra Mammoth"},
[61447]={4, "Traveler's Tundra Mammoth"},
[44151]={16, "Turbo-Charged Flying Machine"},
[65642]={4, "Turbostrider"},
[10796]={34, "Turquoise Raptor"},
[59571]={16, "Twilight Drake"},
[17454]={2, "Unpainted Mechanostrider"},
[42781]={4, "Upper Deck - Spectral Tiger Mount"},
[49193]={16, "Vengeful Nether Drake"},
[64659]={4, "Venomhide Ravasaur"},
[46102]={4, "Venomhide Ravasaur"},
[41517]={16, "Veridian Netherwing Drake"},
[41518]={16, "Violet Netherwing Drake"},
[60024]={16, "Violet Proto-Drake"},
[10799]={34, "Violet Raptor"},
[13819]={2, "Warhorse"},
[64657]={2, "White Kodo"},
[15779]={4, "White Mechanostrider Mod B"},
[54753]={4, "White Polar Bear Mount"},
[6898]={2, "White Ram"},
[39319]={4, "White Riding Talbuk"},
[65645]={4, "White Skeletal Warhorse"},
[468]={4, "White Stallion"},
[16083]={4, "White Stallion"},
[34897]={4, "White War Talbuk"},
[54729]={24, "Winged Steed of the Ebon Blade"},
[581]={4, "Winter Wolf"},
[16081]={4, "Winter Wolf"},
[17229]={4, "Winterspring Frostsaber"},
[59791]={4, "Wooly Mammoth"},
[59793]={4, "Wooly Mammoth"},
[46197]={16, "X-51 Nether-Rocket"},
[46199]={16, "X-51 Nether-Rocket X-TREME"},
[26055]={32, "Yellow Qiraji Battle Tank"}}

--Saved Variables
debug = false                                                           --display debug info if enabled
notWanted = {}                                                          --Mounts that are not wanted to be summoned
removeMount = false                                                     --Enable or disable notWanted mounts
epicfly = true                                                          --Enable or disable epic flying mounts
epicride = true                                                         --Enable or disable epic riding mounts
locationChk = true                                                      --enable or disable specific mounts in special locations
locations = {}                                                          --locations to summon specific mounts(specialMounts)
specialMounts = {}                                                      --special mounts to summon if in a specific location
rndTitle = false                                                        --Randomly change the title when summoning a mount
safeFly = false                                                         --Safe flying dismount if flying

--names to check for cold weather flying
local zoneIndex = {"Howling Fjord", "Borean Tundra", "Dragonblight", "Grizzly Hills", "Zul'Drak", "Sholazar Basin",
            "The Storm Peaks", "Crystalsong Forest", "Icecrown", "Windergrasp", "Coldarra", "The Frozen Sea"}

local nosummonlist = {}                                                 --Stores the last few mounts summoned so it won't summon it again
local lastTime = GetTime()                                             --Safe flying last time that dismount was called

--bindings
BINDING_HEADER_RANDOMMOUNT = "Random Mount"
BINDING_NAME_RANDOMMOUNT_REG = "Auto Summon"
BINDING_NAME_RANDOMMOUNT_RIDING = "Summon Riding"
BINDING_NAME_RANDOMMOUNT_FLYING = "Summon Flying"

function RandomMount_OnLoad()
 SlashCmdList["RandomMount"] = FindMount;
 SLASH_RandomMount1 = "/mnt";
 SLASH_RandomMount2 = "/rmount";
end

function dumyFindMount()
    FindMount()
end

function CanFlyHere( )
	-- Check for flyable area
	if not IsFlyableArea( ) then
        return( false )
    end

	local coldWeather = IsUsableSpell( "Cold Weather Flying" )

	-- Check for Dalaran
    if GetRealZoneText( ) == "Dalaran" then
        if coldWeather then
            local posX, posY = GetPlayerMapPosition("player");
            if GetMinimapZoneText( ) == "Krasus' Landing" then
                return( true )
            elseif GetMinimapZoneText() == "The Underbelly" then
                if posX <= 0.3 then
                    return( true )
                end
            elseif GetMinimapZoneText() == "The Violet Citadel" then
                if (posX - 0.24)^2 + (posY - 0.39)^2 < 0.9 then
                    return( true )
                end
            elseif (posX - 0.87)^2 + (posY - 0.62)^2 < 0.008 then
                return( true )
            elseif (posX - 0.47)^2 + (posY - 0.42)^2 < 0.002 then
                return( true )
            elseif (posX - 0.47)^2 + (posY - 0.38)^2 < 0.002 then
                return( true )
            end
        end
        return( false )
	end
	-- Check for Wintergrasp
	if GetRealZoneText( ) == "Wintergrasp" then
        return( false )
    end
	-- Northrend check
	local zoneText = GetRealZoneText()
	for i, zone in ipairs( zoneIndex ) do
        if zoneText == zone then
			if coldWeather then return( true ) end
			return( false )
		end
	end

	return( true )
end

function GetRidingSkill()
    --get the current riding skill
    for skillIndex = 1, GetNumSkillLines() do
        skillName, isHeader, _, skillRank = GetSkillLineInfo(skillIndex)
        if isHeader == nil then
            if skillName == "Riding" then
                return( skillRank )
            end
        end
    end
    return ( 0 )
end

function HasZoneMounts(flying, qiraji, searchMount, search)
    --check to see if special zone mounts are learned and process search
    for i=1,GetNumCompanions("MOUNT"),1 do
        local _, creatureName, creatureSpellID = GetCompanionInfo("MOUNT", i)
        if search ~= '' then
            if string.find(string.lower(creatureName), string.lower(search)) then
                table.insert(searchMount, i)
            end
        end
        local chk = true
        if creatureName:find("Qiraji") then
            chk = true
            for n, notW in ipairs( notWanted ) do
                if string.find(string.lower(creatureName), string.lower(notW)) then
                    chk = false
                    break
                end
            end
            if chk then
                table.insert(qiraji, i)
            end
        else
            if mountDict[creatureSpellID] then
                if ((mountDict[creatureSpellID][1] / 8) % 2) >= 1 or ((mountDict[creatureSpellID][1] / 16) % 2) >= 1 then
                    table.insert(flying, i)
                end
            else
                PrintHelp(creatureName .. " " .. creatureSpellID .. " not in table, please report on curse.com.", "FF00ff00")
            end
        end
    end
    return flying, qiraji, searchMount
end

function LookForLocation(loc)
    local zone = GetMinimapZoneText( )
    local miniMap = GetRealZoneText( )
    for i, v in ipairs(locations) do
        if string.find(string.lower(zone), string.lower(v)) or string.find(string.lower(miniMap), string.lower(v)) then
            for j, k in ipairs(specialMounts) do
                for i=1,GetNumCompanions("MOUNT"),1 do
                    local _, creatureName = GetCompanionInfo("MOUNT", i)
                    if string.find(string.lower(creatureName), string.lower(k)) then
                        return true
                    end
                end
            end
        end
    end
    return false
end

function lfmChk(creatureName)
	if locationChk then
        for j, k in ipairs(specialMounts) do
            if string.find(string.lower(creatureName), string.lower(k)) then
                return true
            end
        end
	end
	return false
end

function FindMount(arg1)
	local s = 0
	local r
    local qiraji = {}
    local flying = {}
    local search = ""
    local searchMount = {}
	local zoneText = GetRealZoneText()
    local zoneMounts = 2
    local canFly
    local ridingSK = GetRidingSkill()
    local inLocation = false                                --Used to check for location

    if arg1 == "riding" then
        canFly = false
    elseif arg1 == "help" then
        PrintHelp("Random Mount V0.9.5a optional flags:", "FFFFFF00")
        PrintHelp("mnt: rmount: Will summon riding/flying mounts in the appropriate areas. mnt and rmount are interchangeable", "FFFFFF00")
        PrintHelp("riding: Summons riding mounts in flying areas", "FFFFFF00")
        PrintHelp("flying: Attempt to summon a flying mount", "FFFFFF00")
        PrintHelp("help: Display help", "FFFFFF00")
        PrintHelp("% (search Term): Summons a mount based on specified search term \rexample: to summon a skeletal warhorse type: /mnt skeletal", "FFFFFF00")
        PrintHelp("epicfly: Toggle summoning of epic flying mounts", "FFFFFF00")
        PrintHelp("epicride: Toggle summoning of epic riding mounts", "FFFFFF00")
        PrintHelp("config: Prints the current configuration", "FFFFFF00")
        PrintHelp("locfilter: Toggle filter to summon only specific mounts in specific locations", "FFFFFF00")
        PrintHelp("rfilter: Toggle mount filtering", "FFFFFF00")
        PrintHelp("safefly: Toggle double click to dismount while flying", "FFFFFF00")
        PrintHelp("rfilters: List current filters", "FFFFFF00")
        PrintHelp("addloc % (search term): Add % to the location mount filter if locfilter is enabled", "FFFFFF00")
        PrintHelp("addmount % (search term): Add % to the location filter if locfilter is enabled", "FFFFFF00")
        PrintHelp("remove %: Remove all mounts matching % if rfilter is enabled", "FFFFFF00")
        PrintHelp("clear: Clears all filters", "FFFFFF00")
        PrintHelp("clearrem: Clears the mount removal table", "FFFFFF00")
        PrintHelp("clearloc: Clears location filters", "FFFFFF00")
        PrintHelp("clearmount: Clears mount filters for locations", "FFFFFF00")
        PrintHelp("whereami: Prints your zone and mini-map zone, and map coordinates.", "FFFFFF00")
        PrintHelp("title: Enable or disable random title change.", "FFFFFF00")
        PrintHelp("debug: Toggle debug printing for posting error messages", "FFFFFF00")
        PrintHelp("No Flag: Summon a appropriate mount for the area", "FFFFFF00")
        return
    elseif arg1 == "config" then
        if debug then
            PrintHelp("Debug: Enabled", "FF00ff00")
        else
            PrintHelp("Debug: Disabled", "FFff0000")
        end
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ff00")
        else
            PrintHelp("Mount Removal Disabled.", "FFff0000")
        end
        if epicfly then
            PrintHelp("Epic flying enabled.", "FF00ff00")
        else
            PrintHelp("Epic flying disabled.", "FFff0000")
        end
        if epicride then
            PrintHelp("Epic riding enabled.", "FF00ff00")
        else
            PrintHelp("Epic riding disabled.", "FFff0000")
        end
        if locationChk then
            PrintHelp("Locations checked: " .. table.concat(locations, ", "), "FF00ff00")
            PrintHelp("Location Mounts: " .. table.concat(specialMounts, ", "), "FF00ff00")
        else
            PrintHelp("Location checking mount filtering disabled.", "FFff0000")
        end
        if safeFly then
            PrintHelp("Safe flying enabled. Double click to dismount while flying", "FF00ff00")
        else
            PrintHelp("Safe flying disabled.", "FFff0000")
        end
        if rndTitle then
            PrintHelp("Random title enabled.", "FF00ff00")
        else
            PrintHelp("Random title disabled.", "FFff0000")
        end
        return
    elseif arg1 == "whereami" then
        local posX, posY = GetPlayerMapPosition("player")
        PrintHelp("You are in " .. GetRealZoneText( ) .. ", " .. GetMinimapZoneText( ) .. ", " .. posX .. ", " .. posY, "FF00ff00")
        return
    elseif arg1 == "debug" then
        if debug == false then
            debug = true
            PrintHelp("Debug information enabled.", "FF00ff00")
        elseif debug == true then
            debug = false
            PrintHelp("Debug information disabled.", "FFff0000")
        end
        return
    elseif arg1 == "epicfly" then
        if epicfly == false then
            epicfly = true
            PrintHelp("Epic flying enabled.", "FF00ff00")
        elseif epicfly == true then
            epicfly = false
            PrintHelp("Epic flying disabled.", "FFff0000")
        end
        return
    elseif arg1 == "locfilter" then
        if locationChk == false then
            locationChk = true
            PrintHelp("Location mount filtering enabled.", "FF00ff00")
        elseif locationChk == true then
            locationChk = false
            PrintHelp("Location mount filtering disabled.", "FFff0000")
        end
        return
    elseif arg1 == "epicride" then
        if epicride == false then
            epicride = true
            PrintHelp("Epic riding enabled.", "FF00ff00")
        elseif epicride == true then
            epicride = false
            PrintHelp("Epic riding disabled.", "FFff0000")
        end
        return
    elseif arg1 == "rfilter" then
        if removeMount == false then
            removeMount = true
            PrintHelp("Mount removal enabled.", "FF00ff00")
        elseif removeMount == true then
            removeMount = false
            PrintHelp("Mount removal disabled.", "FFff0000")
        end
        return
    elseif arg1 == "safefly" then
        if safeFly == false then
            safeFly = true
            PrintHelp("Safe flying enabled. Double click to dismount while flying", "FF00ff00")
        elseif safeFly == true then
            safeFly = false
            PrintHelp("Safe flying disabled.", "FFff0000")
        end
        return
    elseif arg1 == "rfilters" then
        if removeMount then
            PrintHelp("Mounts filtered: " .. table.concat(notWanted, ", "), "FF00ffff")
        else
            PrintHelp("Mount removal disabled.", "FFff0000")
        end
        return
    elseif arg1 == "title" then
        if rndTitle == false then
            rndTitle = true
            PrintHelp("Random title enabled.", "FF00ff00")
        elseif rndTitle == true then
            rndTitle = false
            PrintHelp("Random title disabled.", "FFff0000")
        end
        return
    elseif arg1 == "clear" then
        notWanted = {}
        locations = {}
        specialMounts = {}
        PrintHelp("All tables cleared.", "FF00ffff")
        return
    elseif arg1 == "clearrem" then
        notWanted = {}
        PrintHelp("Remove mount table cleared.", "FF00ffff")
        return
    elseif arg1 == "clearloc" then
        locations = {}
        PrintHelp("Special location table cleared.", "FF00ffff")
        return
    elseif arg1 == "clearmount" then
        specialMounts = {}
        PrintHelp("Special mount table cleared.", "FF00ffff")
        return
    elseif arg1 == "flying" then
        canFly = true
    elseif arg1:find("addloc") then
        local found = false
        if string.len(string.sub(arg1, 8)) > 0 then
            for n, notW in ipairs( locations ) do
                if string.sub(arg1, 8) == notW then
                    PrintHelp(string.sub(arg1, 8) .. " already added.", "FF00ffff")
                    found = true
                    break
                end
            end
            if not found then
                PrintHelp("Locations matching " .. string.sub(arg1, 8) .. " added to special locations.", "FF00ff00")
                table.insert(locations, string.sub(arg1, 8))
            end
        end
        return
    elseif arg1:find("addmount") then
        local found = false
        if string.len(string.sub(arg1, 10)) > 0 then
            for n, notW in ipairs( specialMounts ) do
                if string.sub(arg1, 10) == notW then
                    PrintHelp(string.sub(arg1, 10) .. " already added to special mounts.", "FF00ffff")
                    found = true
                    break
                end
            end
            if not found then
                PrintHelp("Mounts matching " .. string.sub(arg1, 10) .. " added to special mounts.", "FF00ff00")
                table.insert(specialMounts, string.sub(arg1, 10))
            end
        end
        return
    elseif arg1:find("remove") then
        local found = false
        if string.len(string.sub(arg1, 8)) > 0 then
            for n, notW in ipairs( notWanted ) do
                if string.sub(arg1, 8) == notW then
                    PrintHelp(string.sub(arg1, 8) .. " already added.", "FF00ffff")
                    found = true
                    break
                end
            end
            --PrintHelp(table.concat(notWanted, ", "), "FF00ffff")
            if not found then
                PrintHelp("Mounts matching " .. string.sub(arg1, 8) .. " will no longer be summoned.", "FF00ff00")
                table.insert(notWanted, string.sub(arg1, 8))
            end
        end
        return
    elseif arg1 == "rnd" then
      	r = randomSudo(GetNumCompanions("MOUNT"))
	    PrintHelp(r, "FF00ffff")
    else
        search = arg1
        canFly = CanFlyHere()
    end
    if IsMounted() then
        if safeFly and IsFlying() then
            local curTime = GetTime()
            if curTime < (lastTime + 0.5) then
                Dismount()
                return
            else
                lastTime = curTime
                return
            end
        else
            Dismount()
            return
        end
    end
    if UnitInVehicle(UnitName("player")) then
        VehicleExit()
        return
    end
    if rndTitle then
        local titles = {};
        for i=1,GetNumTitles(),1 do
            if IsTitleKnown(i) == 1 then
                table.insert(titles, i);
            end
        end
        SetCurrentTitle(titles[random(# titles)])
    end
    local flying, qiraji, searchMount = HasZoneMounts(flying, qiraji, searchMount, search)
    if search ~= "" and next (searchMount) == nil then
        PrintHelp("No matching mount found.", "FF00ffff") return
    end
    if locationChk then
        inLocation = LookForLocation()
    end
    local repeatChk = true
    local runawayChk = 0
    numCompanions = GetNumCompanions("MOUNT")
    --if there are less than 10 mounts no real reason to check for repeats
    if numCompanions < 10 then
        repeatChk = false
    end
    if ridingSK >= 75 then
    	repeat
    		r = random(numCompanions)

    		s = TestMount(r, ridingSK, zoneText, canFly, flying, qiraji, searchMount, debug, inLocation, repeatChk)
    		runawayChk = runawayChk + 1                             --No mounts found after 1000 trys so just quit otherwise it will lock up 
    		if runawayChk > 1000 then
                s = true
    		elseif runawayChk > 500 then                            --no acceptable mounts found in the first 500 trys so turn off can fly
                canFly = false
            elseif repeatChk and runawayChk > 250 then              --Turn off repeatChk if no usable mounts are found within the first 250 checks
                repeatChk = false
    		end
    	until s == true
    	if runawayChk > 1000 then
    	   PrintHelp("No usable mounts found", "FFff0000")
    	else
            CallCompanion("MOUNT", r)
            --Repeat Mount check
            table.insert(nosummonlist, r)
            if #nosummonlist > 5 then
                table.remove(nosummonlist, 1)
            end
        end
    end
end

function TestMount(r, ridingSK, zoneText, canFly, flying, qiraji, searchMount, debug, inLocation, repeatChk)
    local _, creatureName, creatureSpellID = GetCompanionInfo("MOUNT", r)
    local mv
    if mountDict[creatureSpellID] then
        mv = mountDict[creatureSpellID][1]
        if mv then
            if removeMount then
                for n, notW in ipairs( notWanted ) do
                    if string.find(string.lower(creatureName), string.lower(notW)) then
                        return false
                    end
                end
            end
            --Repeat Mount check
            if repeatChk then
                for i, m in ipairs(nosummonlist) do
                    if m == r then
                        return false
                    end
                end
            end
            --flying mounts
            if canFly and #flying > 0 and ridingSK >= 225 then
                if ridingSK >= 300 and ((mv/ 16) % 2) >= 1 and epicfly then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 12) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 11) end
                            return true
                        end
                    else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 10) end
                        return true
                    end
                elseif (ridingSK == 225 or not epicfly) and ((mv / 8) % 2) >= 1 then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 22) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 21) end
                            return true
                        end
                    else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 20) end
                        return true
                    end
                end
            --zone specific mounts
            elseif zoneText == "Ahn'Qiraj" and #qiraji > 0 then
                if ridingSK >= 150 and ((mv / 32) % 2) >= 1 then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 37) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 36) end
                            return true
                        end
                    elseif creatureName:find("Qiraji") then
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 35) end
                        return true
                    end
                end
            --Regular Mounts
            else
                if ridingSK >= 150 and ((mv / 4) % 2) >= 1 and epicride then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 52) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 51) end
                            return true
                        end
                    else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 50) end
                        return true
                    end
                elseif (ridingSK == 75 or not epicride) and ((mv / 2) % 2) >= 1 then
                    if #searchMount > 0 then
                        for i, s in ipairs(searchMount) do
                            if r == s then
                                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 62) end
                                return true
                            end
                        end
                    elseif inLocation then
                        if lfmChk(creatureName) then
                            if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 61) end
                            return true
                        end
                    else
                        if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureSpellID][1], zoneText, canFly, 60) end
                        return true
                    end
                end
            end
        end
    end
end



function PrintHelp(cmd, color)
	print(format('|c%s%s|r', color, cmd))
end

function PrintSummon(color, creatureName, r, ridingSK, creatureDict, zoneText, canFly, mountNum)
    canFly = tostring(canFly)
	print(format("|c%s%s - Mnt#:%s - Skill: %s - type:%s - %s - %s - flyZone:%s - cond:%s|r", color, creatureName, r, ridingSK, creatureDict, zoneText, GetMinimapZoneText(), canFly, mountNum))
end

function randomSudo(max)
   local oldrandom = math.random
   local randomtable
   math.random = function ()
      if randomtable == nil then
         randomtable = {}
         for i = 1, max do
            randomtable[i] = oldrandom()
         end
      end
      local x = oldrandom()
      local i = 1 + math.floor(max*x)
      x, randomtable[i] = randomtable[i], x
      return x
   end
end